#音のなるコード表
Copyright © 2022 Sota Fukazawa.

###制作のきっかけ
pythonで動くものを制作するにあたってゲームを作る場合、他の人よりも良いものが自分に作れるとは思えませんでした。相互評価を行うこともあってネット上にあるものを作ったりアレンジすることもあまりしたくなかったので今回のような形になりました。そして根本にあったテーマは「code（プログラム）とchord（和音）を掛けた高度なダジャレ」です。codeとしては難しいことは全くやってないのですが、chordの音は音源を少しいじりました。

##Chord(和音）について
Chordについて分かりやすいサイトを書きに下に置いておきます。
[Chordについてわかりやすいサイト①](https://watanabejunya.com/what-chord/)
[Chordについてわかりやすいサイト②](https://jp.yamaha.com/services/music_pal/study/chord/index.html)

##キャンバス
キャンバスに鍵盤を描画し、ボタンとテキストボックスを設置しました。
ラベルのC3～C5は基準になる鍵盤（Cはド）

```python 
from calendar import c
import tkinter as tk

canvas=tk.Canvas(root,width=1300,height=400,bg="white")
canvas.place(x=0,y=0)

#鍵盤
#C
canvas.create_rectangle(10,100,50,250,fill="white",outline="black",tag="C1")
#C#
canvas.create_rectangle(60,100,100,230,fill="gray",outline="black",tag="C#1")
#D
canvas.create_rectangle(110,100,150,250,fill="white",outline="black",tag="D1")
#D#
canvas.create_rectangle(160,100,200,230,fill="gray",outline="black",tag="D#1")
#E
canvas.create_rectangle(210,100,250,250,fill="white",outline="black",tag="E1")
#F
canvas.create_rectangle(260,100,300,250,fill="white",outline="black",tag="F1")
#F#
canvas.create_rectangle(310,100,350,230,fill="gray",outline="black",tag="F#1")
#G
canvas.create_rectangle(360,100,400,250,fill="white",outline="black",tag="G1")
#G#
canvas.create_rectangle(410,100,450,230,fill="gray",outline="black",tag="G#1")
#A
canvas.create_rectangle(460,100,500,250,fill="white",outline="black",tag="A1")
#A#
canvas.create_rectangle(510,100,550,230,fill="gray",outline="black",tag="A#1")
#B
canvas.create_rectangle(560,100,600,250,fill="white",outline="black",tag="B1")
#C2
canvas.create_rectangle(610,100,650,250,fill="white",outline="black",tag="C2")
#C#2
canvas.create_rectangle(660,100,700,230,fill="gray",outline="black",tag="C#2")
#D2
canvas.create_rectangle(710,100,750,250,fill="white",outline="black",tag="D2")
#D#2
canvas.create_rectangle(760,100,800,230,fill="gray",outline="black",tag="D#2")
#E2
canvas.create_rectangle(810,100,850,250,fill="white",outline="black",tag="E2")
#F2
canvas.create_rectangle(860,100,900,250,fill="white",outline="black",tag="F2")
#F#2
canvas.create_rectangle(910,100,950,230,fill="gray",outline="black",tag="F#2")
#G2
canvas.create_rectangle(960,100,1000,250,fill="white",outline="black",tag="G2")
#G#2
canvas.create_rectangle(1010,100,1050,230,fill="gray",outline="black",tag="G#2")
#A2
canvas.create_rectangle(1060,100,1100,250,fill="white",outline="black",tag="A2")
#A#2
canvas.create_rectangle(1110,100,1150,230,fill="gray",outline="black",tag="A#2")
#B2
canvas.create_rectangle(1160,100,1200,250,fill="white",outline="black",tag="B2")
#C3
canvas.create_rectangle(1210,100,1250,250,fill="white",outline="black",tag="C3")
#C#3
canvas.create_rectangle(1260,100,1300,230,fill="gray",outline="black",tag="C#3")

root.title("コード表")

#ラベル
labell = tk.Label(root,text="コードname")
labell.place(x=40,y=20)
#C1
labell = tk.Label(root,text="C3")
labell.place(x=23,y=270)
#C2
labell = tk.Label(root,text="C4")
labell.place(x=623,y=270)
#C3
labell = tk.Label(root,text="C5")
labell.place(x=1223,y=270)

#テキストボックス
editboxl=tk.Entry(width=9)
editboxl.place(x=120,y=20)
#ボタン
btn=tk.Button(root,text="検索",command=btn_click)
btn.place(x=200,y=20)

root.mainloop()
```
##ボタンが押されたときの処理
・コードネームが入力されたときに押える鍵盤の上に黒い長方形を描画し、設定されたmp3ファイルを再生する。
（下はCが入力されたときの処理）
```python
def btn_click():
    b = editboxl.get()
    
    if b == "C":
        #C
        canvas.create_rectangle(10,100,50,250,fill="black",outline="black",tag="C1")
        #C#
        canvas.create_rectangle(60,100,100,230,fill="gray",outline="black",tag="C#1")
        #D
        canvas.create_rectangle(110,100,150,250,fill="white",outline="black",tag="D1")
        #D#
        canvas.create_rectangle(160,100,200,230,fill="gray",outline="black",tag="D#1")
        #E
        canvas.create_rectangle(210,100,250,250,fill="black",outline="black",tag="E1")
        #F
        canvas.create_rectangle(260,100,300,250,fill="white",outline="black",tag="F1")
        #F#
        canvas.create_rectangle(310,100,350,230,fill="gray",outline="black",tag="F#1")
        #G
        canvas.create_rectangle(360,100,400,250,fill="black",outline="black",tag="G1")
        #G#
        canvas.create_rectangle(410,100,450,230,fill="gray",outline="black",tag="G#1")
        #A
        canvas.create_rectangle(460,100,500,250,fill="white",outline="black",tag="A1")
        #A#
        canvas.create_rectangle(510,100,550,230,fill="gray",outline="black",tag="A#1")
        #B
        canvas.create_rectangle(560,100,600,250,fill="white",outline="black",tag="B1")
        #C2
        canvas.create_rectangle(610,100,650,250,fill="white",outline="black",tag="C2")
        #C#2
        canvas.create_rectangle(660,100,700,230,fill="gray",outline="black",tag="C#2")
        #D2
        canvas.create_rectangle(710,100,750,250,fill="white",outline="black",tag="D2")
        #D#2
        canvas.create_rectangle(760,100,800,230,fill="gray",outline="black",tag="D#2")
        #E2
        canvas.create_rectangle(810,100,850,250,fill="white",outline="black",tag="E2")
        #F2
        canvas.create_rectangle(860,100,900,250,fill="white",outline="black",tag="F2")
        #F#2
        canvas.create_rectangle(910,100,950,230,fill="gray",outline="black",tag="F#2")
        #G2
        canvas.create_rectangle(960,100,1000,250,fill="white",outline="black",tag="G2")
        #G#2
        canvas.create_rectangle(1010,100,1050,230,fill="gray",outline="black",tag="G#2")
        #A2
        canvas.create_rectangle(1060,100,1100,250,fill="white",outline="black",tag="A2")
        #A#2
        canvas.create_rectangle(1110,100,1150,230,fill="gray",outline="black",tag="A#2")
        #B2
        canvas.create_rectangle(1160,100,1200,250,fill="white",outline="black",tag="B2")
        #C3
        canvas.create_rectangle(1210,100,1250,250,fill="white",outline="black",tag="C3")
        #C#3
        canvas.create_rectangle(1260,100,1300,230,fill="gray",outline="black",tag="C#3")      
        
        from playsound import playsound
        playsound("C_majコード.mp3")      
```
##音を出す
"playsound"を用いて音を再生しました。
作製したコード音は、ルート音12種類に対してそれぞれ10種類の120種類。
（maj,m,6th,7th,maj7,m7,add9,sus4,dim,augの10種類）

音は「Studio one」の"Grand Piano"の音源を少しいじったものを使いました。
[音作りに使用したDAW](https://www.mi7.co.jp/products/presonus/studioone/)


```python
from playsound import playsound
        playsound("C_majコード.mp3")  
```



##source code
・source codeは長いので省略したものを記載します。
(実際はCコード以外に全120種類のコードを用意しました。)
```python
from calendar import c
import tkinter as tk

def btn_click():
    b = editboxl.get()
    
    if b == "C":
        #C
        canvas.create_rectangle(10,100,50,250,fill="black",outline="black",tag="C1")
        #C#
        canvas.create_rectangle(60,100,100,230,fill="gray",outline="black",tag="C#1")
        #D
        canvas.create_rectangle(110,100,150,250,fill="white",outline="black",tag="D1")
        #D#
        canvas.create_rectangle(160,100,200,230,fill="gray",outline="black",tag="D#1")
        #E
        canvas.create_rectangle(210,100,250,250,fill="black",outline="black",tag="E1")
        #F
        canvas.create_rectangle(260,100,300,250,fill="white",outline="black",tag="F1")
        #F#
        canvas.create_rectangle(310,100,350,230,fill="gray",outline="black",tag="F#1")
        #G
        canvas.create_rectangle(360,100,400,250,fill="black",outline="black",tag="G1")
        #G#
        canvas.create_rectangle(410,100,450,230,fill="gray",outline="black",tag="G#1")
        #A
        canvas.create_rectangle(460,100,500,250,fill="white",outline="black",tag="A1")
        #A#
        canvas.create_rectangle(510,100,550,230,fill="gray",outline="black",tag="A#1")
        #B
        canvas.create_rectangle(560,100,600,250,fill="white",outline="black",tag="B1")
        #C2
        canvas.create_rectangle(610,100,650,250,fill="white",outline="black",tag="C2")
        #C#2
        canvas.create_rectangle(660,100,700,230,fill="gray",outline="black",tag="C#2")
        #D2
        canvas.create_rectangle(710,100,750,250,fill="white",outline="black",tag="D2")
        #D#2
        canvas.create_rectangle(760,100,800,230,fill="gray",outline="black",tag="D#2")
        #E2
        canvas.create_rectangle(810,100,850,250,fill="white",outline="black",tag="E2")
        #F2
        canvas.create_rectangle(860,100,900,250,fill="white",outline="black",tag="F2")
        #F#2
        canvas.create_rectangle(910,100,950,230,fill="gray",outline="black",tag="F#2")
        #G2
        canvas.create_rectangle(960,100,1000,250,fill="white",outline="black",tag="G2")
        #G#2
        canvas.create_rectangle(1010,100,1050,230,fill="gray",outline="black",tag="G#2")
        #A2
        canvas.create_rectangle(1060,100,1100,250,fill="white",outline="black",tag="A2")
        #A#2
        canvas.create_rectangle(1110,100,1150,230,fill="gray",outline="black",tag="A#2")
        #B2
        canvas.create_rectangle(1160,100,1200,250,fill="white",outline="black",tag="B2")
        #C3
        canvas.create_rectangle(1210,100,1250,250,fill="white",outline="black",tag="C3")
        #C#3
        canvas.create_rectangle(1260,100,1300,230,fill="gray",outline="black",tag="C#3")      
        
        from playsound import playsound
        playsound("C_majコード.mp3")   

canvas=tk.Canvas(root,width=1300,height=400,bg="white")
canvas.place(x=0,y=0)

#鍵盤
#C
canvas.create_rectangle(10,100,50,250,fill="white",outline="black",tag="C1")
#C#
canvas.create_rectangle(60,100,100,230,fill="gray",outline="black",tag="C#1")
#D
canvas.create_rectangle(110,100,150,250,fill="white",outline="black",tag="D1")
#D#
canvas.create_rectangle(160,100,200,230,fill="gray",outline="black",tag="D#1")
#E
canvas.create_rectangle(210,100,250,250,fill="white",outline="black",tag="E1")
#F
canvas.create_rectangle(260,100,300,250,fill="white",outline="black",tag="F1")
#F#
canvas.create_rectangle(310,100,350,230,fill="gray",outline="black",tag="F#1")
#G
canvas.create_rectangle(360,100,400,250,fill="white",outline="black",tag="G1")
#G#
canvas.create_rectangle(410,100,450,230,fill="gray",outline="black",tag="G#1")
#A
canvas.create_rectangle(460,100,500,250,fill="white",outline="black",tag="A1")
#A#
canvas.create_rectangle(510,100,550,230,fill="gray",outline="black",tag="A#1")
#B
canvas.create_rectangle(560,100,600,250,fill="white",outline="black",tag="B1")
#C2
canvas.create_rectangle(610,100,650,250,fill="white",outline="black",tag="C2")
#C#2
canvas.create_rectangle(660,100,700,230,fill="gray",outline="black",tag="C#2")
#D2
canvas.create_rectangle(710,100,750,250,fill="white",outline="black",tag="D2")
#D#2
canvas.create_rectangle(760,100,800,230,fill="gray",outline="black",tag="D#2")
#E2
canvas.create_rectangle(810,100,850,250,fill="white",outline="black",tag="E2")
#F2
canvas.create_rectangle(860,100,900,250,fill="white",outline="black",tag="F2")
#F#2
canvas.create_rectangle(910,100,950,230,fill="gray",outline="black",tag="F#2")
#G2
canvas.create_rectangle(960,100,1000,250,fill="white",outline="black",tag="G2")
#G#2
canvas.create_rectangle(1010,100,1050,230,fill="gray",outline="black",tag="G#2")
#A2
canvas.create_rectangle(1060,100,1100,250,fill="white",outline="black",tag="A2")
#A#2
canvas.create_rectangle(1110,100,1150,230,fill="gray",outline="black",tag="A#2")
#B2
canvas.create_rectangle(1160,100,1200,250,fill="white",outline="black",tag="B2")
#C3
canvas.create_rectangle(1210,100,1250,250,fill="white",outline="black",tag="C3")
#C#3
canvas.create_rectangle(1260,100,1300,230,fill="gray",outline="black",tag="C#3")

root.title("コード表")

#ラベル
labell = tk.Label(root,text="コードname")
labell.place(x=40,y=20)
#C1
labell = tk.Label(root,text="C3")
labell.place(x=23,y=270)
#C2
labell = tk.Label(root,text="C4")
labell.place(x=623,y=270)
#C3
labell = tk.Label(root,text="C5")
labell.place(x=1223,y=270)

#テキストボックス
editboxl=tk.Entry(width=9)
editboxl.place(x=120,y=20)
#ボタン
btn=tk.Button(root,text="検索",command=btn_click)
btn.place(x=200,y=20)

root.mainloop()
```
[This project is licensed under the terms of the MIT license.](http://www.opensource.org/licenses/mit-license.php)

【参考にしたもの】
>https://invisiblepotato.com/python02/